
void out_decoder()
{
 FILE* outFile = get_dbOutFile();

 if (outFile != NULL)
 {
  fprintf(outFile,"music7          EQU     $FEC6                                                             \n");
  fprintf(outFile,"Sound_Byte      EQU     $F256                                                             \n");
  fprintf(outFile,"Wait_Recal      EQU     $F192                                                             \n");
  fprintf(outFile,"Clear_x_d       EQU     $F548                                                             \n");
  fprintf(outFile,"Intensity_5F    EQU     $F2A5                   ; BIOS Intensity routine                  \n");
  fprintf(outFile,"Print_Str_d     EQU     $F37A                   ; BIOS print routine                      \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"INFO_START EQU 0                                                                          \n");
  fprintf(outFile,"BYTE_POSITION EQU 0                                                                       \n");
  fprintf(outFile,"BIT_POSITION EQU 2                                                                        \n");
  fprintf(outFile,"CURRENT_BYTE EQU 3                                                                        \n");
  fprintf(outFile,"CURRENT_UNPACKED_BYTE EQU 4                                                               \n");
  fprintf(outFile,"CURRENT_RLE_COUNTER EQU 5                                                                 \n");
  fprintf(outFile,"CURRENT_RLE_MAPPER EQU 7                                                                  \n");
  fprintf(outFile,"CURRENT_IS_PHRASE EQU 9                                                                   \n");
  fprintf(outFile,"CURRENT_PHRASE_BYTE EQU 11                                                                \n");
  fprintf(outFile,"CURRENT_PHRASE_START EQU 12                                                               \n");
  fprintf(outFile,"INFO_END EQU 14                                                                           \n");
  fprintf(outFile,"STRUCTURE_LENGTH EQU (INFO_END-INFO_START)                                                \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"                BSS                                                                       \n");
  fprintf(outFile,"                ORG $c880       ; well start of our ram space                             \n");
  fprintf(outFile,"current_register:                                                                         \n");
  fprintf(outFile,"                DB 0                                                                      \n");
  fprintf(outFile,"temp:                                                                                     \n");
  fprintf(outFile,"                DB 0                                                                      \n");
  fprintf(outFile,"temp2:                                                                                    \n");
  fprintf(outFile,"                DB 0                                                                      \n");
  fprintf(outFile,"temp3:                                                                                    \n");
  fprintf(outFile,"                DB 0                                                                      \n");
  fprintf(outFile,"calc_coder:                                                                               \n");
  fprintf(outFile,"                DB 0                                                                      \n");
  fprintf(outFile,"calc_bits:                                                                                \n");
  fprintf(outFile,"                DB 0                                                                      \n");
  fprintf(outFile,"ym_data_len:                                                                              \n");
  fprintf(outFile,"                DW 0                                                                      \n");
  fprintf(outFile,"ym_data_current:                                                                          \n");
  fprintf(outFile,"                DW 0                                                                      \n");
  fprintf(outFile,"ym_name:                                                                                  \n");
  fprintf(outFile,"                DW 0                                                                      \n");
  fprintf(outFile,"ym_data_start:                                                                            \n");
  fprintf(outFile,"                CODE                                                                      \n");
  fprintf(outFile,";***************************************************************************              \n");
  fprintf(outFile,"                ORG     0                                                                 \n");
  fprintf(outFile,"; start of vectrex memory with cartridge name...                                          \n");
  fprintf(outFile,"                DB      \"g GCE 1998\", $80 ; 'g' is copyright sign                         \n");
  fprintf(outFile,"                DW      music7            ; music from the rom                            \n");
  fprintf(outFile,"                DB      $F8, $50, $20, -$56; hight, width, rel y, rel x (from 0,0)        \n");
  fprintf(outFile,"                DB      \"VECTREX YM-SOUND\", $80; some game information, ending with $80   \n");
  fprintf(outFile,"                DB      $F8, $50, $5, -$6d; hight, width, rel y, rel x (from 0,0)         \n");
  fprintf(outFile,"                DB      \"CHRISTOPHER SALOMON\", $80; some game information, ending with $80\n");
  fprintf(outFile,"                DB      0                 ; end of game header                            \n");
  fprintf(outFile,";***************************************************************************              \n");
  fprintf(outFile,"; here the cartridge program starts off                                                   \n");
  fprintf(outFile,"entry_point:                                                                              \n");
  fprintf(outFile,"new_game:                                                                                 \n");
  fprintf(outFile,"                ldu     #SONG_DATA                                                        \n");
  fprintf(outFile,"                JSR     init_ym_sound                                                       \n");
  fprintf(outFile,"main_loop:                                                                                \n");
  fprintf(outFile,"                JSR     Wait_Recal              ; sets dp to d0, and pos at 0, 0          \n");
  fprintf(outFile,"                JSR     Intensity_5F            ; Sets the intensity of the                 \n");
  fprintf(outFile,"                                                ; vector beam to $5f                      \n");
  fprintf(outFile,"                LDU     ym_name                 ; address of string                       0 \n");
  fprintf(outFile,"                LDA     #$10                    ; Text position relative Y                \n");
  fprintf(outFile,"                LDB     #-$70                   ; Text position relative X                \n");
  fprintf(outFile,"                JSR     Print_Str_d             ; Vectrex BIOS print routine              \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"                JSR     do_ym_sound                                                       \n");
  fprintf(outFile,"                ldd     ym_data_current                                                   \n");
  fprintf(outFile,"                beq     new_game          ; loop default                                  \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"                BRA     main_loop         ; go back to main loop                          \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,";***************************************************************************              \n");
  fprintf(outFile,"do_ym_sound:                                                                              \n");
  fprintf(outFile,"                ldd     ym_data_current                                                   \n");
  fprintf(outFile,"                beq     do_ym_sound_done                                                  \n");
  fprintf(outFile,"                subd    #1                                                                \n");
  fprintf(outFile,"                std     ym_data_current                                                   \n");
  fprintf(outFile,"                clra                                                                      \n");
  fprintf(outFile,"                sta     current_register                                                  \n");
  fprintf(outFile,"                ldu     #ym_data_start                                                    \n");
  fprintf(outFile,"next_reg:                                                                                 \n");
  fprintf(outFile,"                jsr    get_current_byte                                                   \n");
  fprintf(outFile,"                lda    current_register                                                   \n");
  fprintf(outFile,"                ; A PSG reg                                                               \n");
  fprintf(outFile,"                ; B data                                                                  \n");
  fprintf(outFile,"                jsr Sound_Byte                                                            \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"                leau    STRUCTURE_LENGTH,u                                                \n");
  fprintf(outFile,"                inc     current_register                                                  \n");
  fprintf(outFile,"                lda     current_register                                                  \n");
  fprintf(outFile,"                cmpa    #11                                                               \n");
  fprintf(outFile,"                bne     next_reg                                                          \n");
  fprintf(outFile,"do_ym_sound_done:                                                                         \n");
  fprintf(outFile,"                RTS                                                                       \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"no_valid_byte:                                                                            \n");
  fprintf(outFile,"; no we must look at the bits                                                             \n");
  fprintf(outFile,"; a will be our bit register                                                              \n");
  fprintf(outFile,";;;;;;;;;;;;;;;;;;; GET_BIT START                                                         \n");
  fprintf(outFile,"                ldb     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"                bne     byte_ready_1                                                      \n");
  fprintf(outFile,"; load a new byte                                                                         \n");
  fprintf(outFile,"                ldx     BYTE_POSITION,u                                                   \n");
  fprintf(outFile,"                ldb     ,x+                                                               \n");
  fprintf(outFile,"                stb     CURRENT_BYTE,u                                                    \n");
  fprintf(outFile,"                stx     BYTE_POSITION,u                                                   \n");
  fprintf(outFile,"                ldb     #$80                                                              \n");
  fprintf(outFile,"                stb     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"byte_ready_1:                                                                             \n");
  fprintf(outFile,"; bit position correct here                                                               \n");
  fprintf(outFile,";                                                                                         \n");
  fprintf(outFile,"; remember we use one bit now!                                                            \n");
  fprintf(outFile,"                lsr     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"; is the bit at the current position set?                                                 \n");
  fprintf(outFile,"                andb    CURRENT_BYTE,u                                                    \n");
  fprintf(outFile,";;;;;;;;;;;;;;;;;;; GET_BIT END                                                           \n");
  fprintf(outFile,"; zero flag show bit                                                                      \n");
  fprintf(outFile,"; A is 1 or zero                                                                          \n");
  fprintf(outFile,"                lbne     no_single_byte                                                   \n");
  fprintf(outFile,"single_byte:                                                                              \n");
  fprintf(outFile,"                ; must be zero                                                            \n");
  fprintf(outFile,"                ; 1 is allways only 8 bit...                                              \n");
  fprintf(outFile,"                inc      CURRENT_RLE_COUNTER+1,u                                          \n");
  fprintf(outFile,"dechifer:                                                                                 \n");
  fprintf(outFile,"                clr       calc_bits                                                       \n");
  fprintf(outFile,"                clr       calc_coder                                                      \n");
  fprintf(outFile,"try_next_bit:                                                                             \n");
  fprintf(outFile,"                lsl       calc_coder                                                      \n");
  fprintf(outFile,"                inc       calc_bits    ; increase used bits                               \n");
  fprintf(outFile,";;;;;;;;;;;; GET_BIT_START                                                                \n");
  fprintf(outFile,"                ldb     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"                bne     byte_ready                                                        \n");
  fprintf(outFile,"; load a new byte                                                                         \n");
  fprintf(outFile,"                ldx     BYTE_POSITION,u                                                   \n");
  fprintf(outFile,"                ldb     ,x+                                                               \n");
  fprintf(outFile,"                stb     CURRENT_BYTE,u                                                    \n");
  fprintf(outFile,"                stx     BYTE_POSITION,u                                                   \n");
  fprintf(outFile,"                ldb     #$80                                                              \n");
  fprintf(outFile,"                stb     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"byte_ready:                                                                               \n");
  fprintf(outFile,"; bit position correct here                                                               \n");
  fprintf(outFile,";                                                                                         \n");
  fprintf(outFile,"; remember we use one bit now!                                                            \n");
  fprintf(outFile,"                lsr     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"; is the bit at the current position set?                                                 \n");
  fprintf(outFile,"                andb    CURRENT_BYTE,u                                                    \n");
  fprintf(outFile,"                beq     no_add     ; and if non zero                                      \n");
  fprintf(outFile,"                inc     calc_coder                                                        \n");
  fprintf(outFile,";;;;;;;;;;;; GET_BIT_END                                                                  \n");
  fprintf(outFile,"no_add:                                                                                   \n");
  fprintf(outFile,"; we load one complete set of mapper index, bits, coder, map-value                        \n");
  fprintf(outFile,"                ldx       CURRENT_RLE_MAPPER,u                                            \n");
  fprintf(outFile,"search_again:                                                                             \n");
  fprintf(outFile,"                leax      3,x                                                             \n");
  fprintf(outFile,"                lda       ,x          ; load bits from map                                \n");
  fprintf(outFile,"                anda      #127         ; map out phrases                                  \n");
  fprintf(outFile,"                cmpa      calc_bits      ; neu                                            \n");
  fprintf(outFile,"                bgt       try_next_bit ; neu                                              \n");
  fprintf(outFile,"                bne       search_again                                                    \n");
  fprintf(outFile,"                ldb       1,x          ; load coder-byte                                  \n");
  fprintf(outFile,"                cmpb      calc_coder                                                      \n");
  fprintf(outFile,"                bne       search_again                                                    \n");
  fprintf(outFile,"                ldb       2,x           ; load current mapped byte!                       \n");
  fprintf(outFile,"; in b is the byte value we sought                                                        \n");
  fprintf(outFile,"; test for phrase                                                                         \n");
  fprintf(outFile,"                lda       ,x          ; load bits from map                                \n");
  fprintf(outFile,"                anda     #128         ; map in phrases only                               \n");
  fprintf(outFile,"                beq      no_phrase_d                                                      \n");
  fprintf(outFile,"; if phrase, than in b the count of the phrase used                                       \n");
  fprintf(outFile,"                ldx      CURRENT_PHRASE_START,u                                           \n");
  fprintf(outFile,"                tstb                                                                      \n");
  fprintf(outFile,"                beq     phrase_found                                                      \n");
  fprintf(outFile,"next_phrase:                                                                              \n");
  fprintf(outFile,"                lda     ,x+                                                               \n");
  fprintf(outFile,"                leax    a,x                                                               \n");
  fprintf(outFile,"                decb                                                                      \n");
  fprintf(outFile,"                bne     next_phrase                                                       \n");
  fprintf(outFile,"phrase_found:                                                                             \n");
  fprintf(outFile,"                stx     CURRENT_IS_PHRASE,u                                               \n");
  fprintf(outFile,"                clr     CURRENT_PHRASE_BYTE,u                                             \n");
  fprintf(outFile,"                bra      out                                                              \n");
  fprintf(outFile,"no_phrase_d:                                                                              \n");
  fprintf(outFile,"                clr      CURRENT_IS_PHRASE,u                                              \n");
  fprintf(outFile,"                clr      CURRENT_IS_PHRASE+1,u                                            \n");
  fprintf(outFile,"                stb      CURRENT_UNPACKED_BYTE,u                                          \n");
  fprintf(outFile,"out:                                                                                      \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"; U pointer to data structure                                                             \n");
  fprintf(outFile,"; A number of register                                                                    \n");
  fprintf(outFile,"get_current_byte:                                                                         \n");
  fprintf(outFile,"; do we have a byte that is valid?                                                        \n");
  fprintf(outFile,"                ldd      CURRENT_RLE_COUNTER,u                                            \n");
  fprintf(outFile,"                beq      no_valid_byte                                                    \n");
  fprintf(outFile,"; yep... use current byte                                                                 \n");
  fprintf(outFile,"                ldx       CURRENT_IS_PHRASE,u                                             \n");
  fprintf(outFile,"                beq       no_phrase                                                       \n");
  fprintf(outFile,"                lda       ,x+ ; length of phrase                                          \n");
  fprintf(outFile,"                ldb       CURRENT_PHRASE_BYTE,u                                           \n");
  fprintf(outFile,"                ldb       b,x ; this is the current byte                                  \n");
  fprintf(outFile,"                stb       CURRENT_UNPACKED_BYTE,u                                         \n");
  fprintf(outFile,"                inc       CURRENT_PHRASE_BYTE,u                                           \n");
  fprintf(outFile,"                cmpa      CURRENT_PHRASE_BYTE,u                                           \n");
  fprintf(outFile,"                bne       counter_not_minus_one                                           \n");
  fprintf(outFile,"                clr       CURRENT_PHRASE_BYTE,u                                           \n");
  fprintf(outFile,"                ldd       CURRENT_RLE_COUNTER,u                                           \n");
  fprintf(outFile,"no_phrase:                                                                                \n");
  fprintf(outFile,"                subd      #1                                                              \n");
  fprintf(outFile,"                std       CURRENT_RLE_COUNTER,u                                           \n");
  fprintf(outFile,"counter_not_minus_one:                                                                    \n");
  fprintf(outFile,"                ldb       CURRENT_UNPACKED_BYTE,u                                         \n");
  fprintf(outFile,"                rts                                                                       \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"no_single_byte:                                                                           \n");
  fprintf(outFile,"; non single byte here... must decode                                                     \n");
  fprintf(outFile,"; first we look for how many bits the RLE counter spreads                                 \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"                ; we already encountered a 1                                              \n");
  fprintf(outFile,"                ; and we allways use + 2                                                  \n");
  fprintf(outFile,"                lda     #2                                                                \n");
  fprintf(outFile,"                sta     temp                                                              \n");
  fprintf(outFile,"more_bits:                                                                                \n");
  fprintf(outFile,"                inc     temp                                                              \n");
  fprintf(outFile,";;;;;;;;;;;;;;;;;;; GET_BIT START                                                         \n");
  fprintf(outFile,"                ldb     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"                bne     byte_ready_2                                                      \n");
  fprintf(outFile,"; load a new byte                                                                         \n");
  fprintf(outFile,"                ldx     BYTE_POSITION,u                                                   \n");
  fprintf(outFile,"                ldb     ,x+                                                               \n");
  fprintf(outFile,"                stb     CURRENT_BYTE,u                                                    \n");
  fprintf(outFile,"                stx     BYTE_POSITION,u                                                   \n");
  fprintf(outFile,"                ldb     #$80                                                              \n");
  fprintf(outFile,"                stb     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"byte_ready_2:                                                                             \n");
  fprintf(outFile,"; bit position correct here                                                               \n");
  fprintf(outFile,";                                                                                         \n");
  fprintf(outFile,"; remember we use one bit now!                                                            \n");
  fprintf(outFile,"                lsr     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"; is the bit at the current position set?                                                 \n");
  fprintf(outFile,"                andb    CURRENT_BYTE,u                                                    \n");
  fprintf(outFile,";;;;;;;;;;;;;;;;;;; GET_BIT END                                                           \n");
  fprintf(outFile,"                bne     more_bits                                                         \n");
  fprintf(outFile,"; in temp is the # of bits for the counter                                                \n");
  fprintf(outFile,"; the following '#temp' bits represent the RLE count                                      \n");
  fprintf(outFile,"; lsb first                                                                               \n");
  fprintf(outFile,"                incb            ; we start at 1, since zero is an                         \n");
  fprintf(outFile,"                                ; 'own' 'subroutine',                                     \n");
  fprintf(outFile,"                                ; which doesn't manipulate the temps                      \n");
  fprintf(outFile,"                stb     temp2   ; bit counter for shifting                                \n");
  fprintf(outFile,"                stb     temp3   ; bit counter for shifting                                \n");
  fprintf(outFile,"go_on:                                                                                    \n");
  fprintf(outFile,";;;;;;;;;;;;;;;;;;; GET_BIT START                                                         \n");
  fprintf(outFile,"                ldb     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"                bne     byte_ready_3                                                      \n");
  fprintf(outFile,"; load a new byte                                                                         \n");
  fprintf(outFile,"                ldx     BYTE_POSITION,u                                                   \n");
  fprintf(outFile,"                ldb     ,x+                                                               \n");
  fprintf(outFile,"                stb     CURRENT_BYTE,u                                                    \n");
  fprintf(outFile,"                stx     BYTE_POSITION,u                                                   \n");
  fprintf(outFile,"                ldb     #$80                                                              \n");
  fprintf(outFile,"                stb     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"byte_ready_3:                                                                             \n");
  fprintf(outFile,"; bit position correct here                                                               \n");
  fprintf(outFile,";                                                                                         \n");
  fprintf(outFile,"; remember we use one bit now!                                                            \n");
  fprintf(outFile,"                lsr     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"; is the bit at the current position set?                                                 \n");
  fprintf(outFile,"                andb    CURRENT_BYTE,u                                                    \n");
  fprintf(outFile,"                beq     end_here_3                                                        \n");
  fprintf(outFile,"; return 1                                                                                \n");
  fprintf(outFile,"                ldb     #1                                                                \n");
  fprintf(outFile,"end_here_3:                                                                               \n");
  fprintf(outFile,";;;;;;;;;;;;;;;;;;; GET_BIT END                                                           \n");
  fprintf(outFile,"; in D now one bit at the right position for the RLE counter                              \n");
  fprintf(outFile,"                stb     CURRENT_RLE_COUNTER+1,u                                           \n");
  fprintf(outFile,"; the first 3 (here only the first one) rounds                                            \n");
  fprintf(outFile,"; we need not check for temp, since it is at least 3...                                   \n");
  fprintf(outFile,"go_on_2:                                                                                  \n");
  fprintf(outFile,";;;;;;;;;;;;;;;;;;; GET_BIT START                                                         \n");
  fprintf(outFile,"                ldb     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"                bne     byte_ready_4                                                      \n");
  fprintf(outFile,"; load a new byte                                                                         \n");
  fprintf(outFile,"                ldx     BYTE_POSITION,u                                                   \n");
  fprintf(outFile,"                ldb     ,x+                                                               \n");
  fprintf(outFile,"                stb     CURRENT_BYTE,u                                                    \n");
  fprintf(outFile,"                stx     BYTE_POSITION,u                                                   \n");
  fprintf(outFile,"                ldb     #$80                                                              \n");
  fprintf(outFile,"                stb     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"byte_ready_4:                                                                             \n");
  fprintf(outFile,"; bit position correct here                                                               \n");
  fprintf(outFile,";                                                                                         \n");
  fprintf(outFile,"; remember we use one bit now!                                                            \n");
  fprintf(outFile,"                lsr     BIT_POSITION,u                                                    \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"; is the bit at the current position set?                                                 \n");
  fprintf(outFile,"                andb    CURRENT_BYTE,u                                                    \n");
  fprintf(outFile,"                beq     end_here_4                                                        \n");
  fprintf(outFile,"; return 1                                                                                \n");
  fprintf(outFile,"                ldb     #1                                                                \n");
  fprintf(outFile,"end_here_4:                                                                               \n");
  fprintf(outFile,"                clra                                                                      \n");
  fprintf(outFile,"shifting_not_yet_done:                                                                    \n");
  fprintf(outFile,"                      LSLA               ; LSR A                                          \n");
  fprintf(outFile,"                      LSLB               ; LSR B                                          \n");
  fprintf(outFile,"                      BCC no_carry       ; if no carry, than exit                         \n");
  fprintf(outFile,"                      ORA #1             ; otherwise underflow from A to 7bit of B        \n");
  fprintf(outFile,"no_carry:                                                                                 \n");
  fprintf(outFile,"                dec     temp3                                                             \n");
  fprintf(outFile,"                bne     shifting_not_yet_done                                             \n");
  fprintf(outFile,"shifting_done:                                                                            \n");
  fprintf(outFile,"; in D now one bit at the right position for the RLE counter                              \n");
  fprintf(outFile,"                addd    CURRENT_RLE_COUNTER,u                                             \n");
  fprintf(outFile,"                std     CURRENT_RLE_COUNTER,u                                             \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"                inc     temp2                                                             \n");
  fprintf(outFile,"                lda     temp2                                                             \n");
  fprintf(outFile,"                sta     temp3                                                             \n");
  fprintf(outFile,"                cmpa    temp                                                              \n");
  fprintf(outFile,"                bne     go_on_2                                                           \n");
  fprintf(outFile,"; now the current counter should be set                                                   \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"; we still need to dechifer the following byte...                                         \n");
  fprintf(outFile,"                bra       dechifer                                                        \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"init_ym_sound:                                                                            \n");
  fprintf(outFile,"                ldx     #ym_data_start                                                    \n");
  fprintf(outFile,"                ldd     #(STRUCTURE_LENGTH*11)                                            \n");
  fprintf(outFile,"                jsr     Clear_x_d                                                         \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"                ldy     ,u++                                                              \n");
  fprintf(outFile,"                ldd     ,y                                                                \n");
  fprintf(outFile,"                std     ym_data_len                                                       \n");
  fprintf(outFile,"                std     ym_data_current                                                   \n");
  fprintf(outFile,"                ldb     #11                                                               \n");
  fprintf(outFile,"next_reg_init:                                                                            \n");
  fprintf(outFile,"                ldy     ,u++                                                              \n");
  fprintf(outFile,"                sty     CURRENT_RLE_MAPPER,x                                              \n");
  fprintf(outFile,"                ldy     ,u++                                                              \n");
  fprintf(outFile,"                sty     CURRENT_PHRASE_START,x                                            \n");
  fprintf(outFile,"                ldy     ,u++                                                              \n");
  fprintf(outFile,"                sty     BYTE_POSITION,x                                                   \n");
  fprintf(outFile,"                leax    STRUCTURE_LENGTH,x                                                \n");
  fprintf(outFile,"                decb                                                                      \n");
  fprintf(outFile,"                bne     next_reg_init                                                     \n");
  fprintf(outFile,"                stu     ym_name                                                           \n");
  fprintf(outFile,"                RTS                                                                       \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,"                                                                                          \n");
  fprintf(outFile,";***************************************************************************              \n");
  fprintf(outFile,"                END entry_point                                                           \n");
  fprintf(outFile,";***************************************************************************              \n");
  fprintf(outFile,"\n");
 }
}






















